---
name: Feature request
about: Suggest an idea for this project

---

# Feature request

## Description
Please include a summary of the change and which issue is fixed. Please also include relevant motivation and context. List any dependencies that are required for this change.

Fixes #(issue)

## Type of change
Please delete options that are not relevant.

- [ ] New feature (non-breaking change which adds functionality)
- [ ] Change (changes in existing functionality)
- [ ] Deprecate (soon-to-be removed features)
- [ ] Remove (remove files or features)
- [ ] Fix (a bug fix)
- [ ] Security ... (in case of vulnerabilities)
- [ ] Bug fix (non-breaking change which fixes an issue)
- [ ] Breaking change (fix or feature that would cause existing functionality to not work as expected)
- [ ] This change requires a documentation update

## How has this been tested?
Please describe the tests that you ran to verify your changes. Provide instructions so we can reproduce. Please also list any relevant details for your test configuration

- [ ] Test A
- [ ] Test B

### Test environment:

 | | |
 ---- | ----
**Platform** | < _(e.g. iPhoneX)_ >
**Operating System** | < _(e.g. iOS 12.3 Beta 6)_ >
**Browser** | < _(e.g. Google Chrome 74.0.3729.131)_ >
**Additional Context** | < _(e.g. version, other extensions, ...)_ >

# Checklist:
- [ ] My code follows the style guidelines of this project
- [ ] I have performed a self-review of my own code
- [ ] I have commented my code, particularly in hard-to-understand areas
- [ ] I have made corresponding changes to the documentation
- [ ] My changes generate no new warnings
- [ ] I have added tests that prove my fix is effective or that my feature works
- [ ] New and existing unit tests pass locally with my changes
- [ ] Any dependent changes have been merged and published in downstream modules
